#Jun-Hong Chen and Connor Skorge
#Campus School Code

import board, time, neopixel, touchio, digitalio, pwmio

from audiopwmio import PWMAudioOut as AudioOut
from audiocore import WaveFile
from adafruit_led_animation.animation.chase import Chase
from adafruit_led_animation.animation.comet import Comet
from adafruit_led_animation.animation.pulse import Pulse
from adafruit_led_animation.animation.rainbowchase import RainbowChase
from adafruit_led_animation.animation.colorcycle import ColorCycle

#Setup speaker
speaker = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker.direction = digitalio.Direction.OUTPUT
speaker.value = True
audio = AudioOut(board.SPEAKER)

#Setup touchpad
touchpad_A2 = touchio.TouchIn(board.A2)
touchpad_A3 = touchio.TouchIn(board.A3)
touchpad_A4 = touchio.TouchIn(board.A4)
touchpad_A5 = touchio.TouchIn(board.A5)
touchpad_A6 = touchio.TouchIn(board.A6)

path = "BCsounds/"

from adafruit_led_animation.color import (
    AMBER, #(255, 100, 0)
    AQUA, # (50, 255, 255)
    BLACK, #OFF (0, 0, 0)
    BLUE, # (0, 0, 255)
    CYAN, # (0, 255, 255)
    GOLD, # (255, 222, 30)
    GREEN, # (0, 255, 0)
    JADE, # (0, 255, 40)
    MAGENTA, #(255, 0, 20)
    OLD_LACE, # (253, 245, 230)
    ORANGE, # (255, 40, 0)
    PINK, # (242, 90, 255)
    PURPLE, # (180, 0, 255)
    RED, # (255, 0, 0)
    TEAL, # (0, 255, 120)
    WHITE, # (255, 255, 255)
    YELLOW, # (255, 150, 0)
    RAINBOW # a list of colors to cycle through
    # RAINBOW is RED, ORANGE, YELLOW, GREEN, BLUE, and PURPLE ((255, 0, 0), (255, 40, 0), (255, 150, 0), (0, 255, 0), (0, 0, 255), (180, 0, 255))
)

INDIGO = (63, 0, 255)
VIOLET = (127, 0, 255)
MAROON = (128, 0, 0)

strip_pin = board.A1
strip_num_of_lights = 30
strip = neopixel.NeoPixel(strip_pin, strip_num_of_lights, brightness = 0.5, auto_write = False)

colors = [MAROON, GOLD]

colors2 = [MAROON, GOLD, BLUE, PURPLE, GREEN, AMBER]

#Setup animations
chase_strip = Chase(strip, speed = 0.1, color = WHITE, size = 1, spacing = 1)

comet_strip = Comet(strip, speed = 0.01, color = GOLD, tail_length = int(strip_num_of_lights/3), bounce = True)

pulse_strip = Pulse(strip, speed = 0.05, color = MAROON, period = 1)

colorcycle_strip2 = ColorCycle(strip, 0.1, colors = colors2)

colorcycle_strip = ColorCycle(strip, 0.1, colors = colors)

#touchpad, animations, and sounds
touch_pad = [touchpad_A2, touchpad_A3, touchpad_A4, touchpad_A5, touchpad_A6]

animations = [chase_strip, comet_strip, pulse_strip, colorcycle_strip2, colorcycle_strip]

sounds = ["football.wav", "hockey.wav", "for-boston.wav", "we-are-bc.wav", "basketball.wav"]

def play_sound(filename):
    with open(path + filename, "rb") as wave_file:
        wave = WaveFile(wave_file)
        audio.play(wave)
        while audio.playing:
            animations[i].animate()


while True:
    touched = False
    for i in range(5):
        if touch_pad[i].value:
            play_sound(sounds[i])
            touched = True
        if touched == False:
            strip.fill(BLACK)



